
#pragma once

#ifndef CONTROLS_H
#define CONTROLS_H

#ifndef _SET_
#include <set>
#endif

// CStaticDialog dialog
#ifndef IDD_DIALOG_STATIC
#define IDD_DIALOG_STATIC       11116
#define HE_IDB_CLV_CHECK		10998
#define IDC_STATIC_TEXT         1000
#endif

class CStaticDialog : public CDialog
{
	DECLARE_DYNCREATE( CStaticDialog )
	enum { IDD = IDD_DIALOG_STATIC };
	CStatic cStatic;

public:
	CStaticDialog( CWnd* pParent = NULL );   // standard constructor
	virtual ~CStaticDialog( );
	void Create( );
 
	void SetStaticString( LPCTSTR inStr );
protected:
	virtual void DoDataExchange( CDataExchange* pDX );    // DDX/DDV support
	virtual BOOL OnInitDialog( );

	DECLARE_MESSAGE_MAP( )
};

// . CHEComboBox ..........................................................................
typedef struct _combobox_extended
{
	_combobox_extended( )
		:item( -1 )
		,userData( 0 )
		,hIcon( NULL )
		,iIcon( 0 )
		,offset( 0 )
	{ }
	DWORD_PTR item;
	DWORD_PTR userData;
	CString strText;
	HICON hIcon;
	ULONG iIcon;
	long offset;

}COMBOBOXEX_ITEM, *LPCOMBOBOXEX_ITEM;

struct _CHEComboBoxComp
{
	bool operator( ) ( COMBOBOXEX_ITEM s1, COMBOBOXEX_ITEM s2 ) const
	{
		return s1.item < s2.item;
	}
};

#define HECOMBO_USECHECKS	0x0001

class CHEComboBox : public CComboBox
{
	long styles;
	CImageList* pImgList;
	static LPCTSTR null_str;

	typedef std::set< COMBOBOXEX_ITEM, _CHEComboBoxComp >::iterator ItemsExIt;
	typedef std::set< COMBOBOXEX_ITEM, _CHEComboBoxComp >::reverse_iterator ItemsExRevIt;
	std::set< COMBOBOXEX_ITEM, _CHEComboBoxComp > itemsEx;

public:
	CHEComboBox( )
		:pImgList( NULL )
		,styles( 0 )
	{ }
	void InsertItem( LPCOMBOBOXEX_ITEM pItem );
	void InsertItemAt( LPCOMBOBOXEX_ITEM pItem );
	void SetImageList( CImageList* inIList ) { pImgList= inIList; }
	COMBOBOXEX_ITEM* GetCurItem( )
	{
		COMBOBOXEX_ITEM temp;
		if( GetCurSel( ) < 0 )
			return NULL;

		temp.item= (int)GetCurSel( );
		return &*itemsEx.find( temp );
	}
	//our data so these work without a valid HWND
	//can delete user data in Dialog destructor
	long GetCountEx( ) { return (long)itemsEx.size( ); }
	DWORD_PTR GetItemDataEx( long pos );
	void SetHEStyles( long inStyles );

public:
	virtual int CompareItem( LPCOMPAREITEMSTRUCT lpCompareItemStruct );
	virtual void DrawItem( LPDRAWITEMSTRUCT lpDrawItemStruct );
	virtual void MeasureItem( LPMEASUREITEMSTRUCT lpMeasureItemStruct );
	virtual BOOL PreTranslateMessage( MSG* pMsg );

protected:
	virtual void PreSubclassWindow( );

protected:
DECLARE_MESSAGE_MAP( )
	afx_msg void OnLButtonDown( UINT nFlags, CPoint point );
	afx_msg BOOL OnMouseWheel( UINT nFlags, short zDelta, CPoint pt );
};

// CDialogBarEx dialog ...........................................

#define FDB_CTLCOLOR	11234

typedef struct tagFRMDLGBAR
{
	NMHDR	hdr;
	HBRUSH	hbr;
	CDC*	pDC;
	UINT	nCtlColor;
	LPARAM	lParam;

} FRMDLGBAR, *LPFRMDLGBAR;

class CDialogBarEx : public CDialogBar
{
DECLARE_DYNAMIC( CDialogBarEx )
	CWnd* pNotify;
public:
	void SetNotify( CWnd* inWnd ) { pNotify= inWnd; }

DECLARE_MESSAGE_MAP( )
	afx_msg HBRUSH OnCtlColor( CDC* pDC, CWnd* pWnd, UINT nCtlColor );
};

// This is part of the Professional User Interface Suite library.
// Copyright (C) 2001-2004 FOSS Software, Inc.
// All rights reserved.
//
// http://www.prof-uis.com
// http://www.fossware.com
// mailto:foss@fossware.com

// Warranties and Disclaimers:
// THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND
// INCLUDING, BUT NOT LIMITED TO, WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT.
// IN NO EVENT WILL FOSS SOFTWARE INC. BE LIABLE FOR ANY DIRECT,
// INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY OR CONSEQUENTIAL DAMAGES,
// INCLUDING DAMAGES FOR LOSS OF PROFITS, LOSS OR INACCURACY OF DATA,
// INCURRED BY ANY PERSON FROM SUCH PERSON'S USAGE OF THIS SOFTWARE
// EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

//#if (!defined __EXT_STATUSCONTROLBAR_H)
//#define __EXT_STATUSCONTROLBAR_H
//
//#if _MSC_VER > 1000
//#pragma once
//#endif // _MSC_VER > 1000
// ExtStatusControlBar.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CExtStatusControlBar window
// Used in CFrameDialog

class CExtStatusControlBar : public CStatusBar
{
// Construction
public:

	CExtStatusControlBar();

// Attributes
public:

	// Operations
public:
	
	int GetPanesCount() const{
		return m_nCount;
	}
	
	void SetPaneWidth(int nIndex, int nWidth)
	{
		_STATUSBAR_PANE_ pane;
		PaneInfoGet(nIndex, &pane);
		pane.cxText = nWidth;
		PaneInfoSet(nIndex, &pane);
	}
	
	BOOL AddPane(
		UINT nID,	// ID of the  pane
		int nIndex	// index of the pane
		);

	BOOL RemovePane(
		UINT nID	// ID of the pane
		);

	BOOL AddPaneControl(CWnd* pWnd, UINT nID, BOOL bAutoDestroy)
	{
		return AddPaneControl( pWnd->GetSafeHwnd(), nID, bAutoDestroy);
	}
	
	BOOL AddPaneControl(HWND hWnd, UINT nID, BOOL bAutoDestroy);
	
	void DisableControl( int nIndex, BOOL bDisable=TRUE)
	{
		UINT uItemID = GetItemID(nIndex);
		for ( int i = 0; i < m_arrPaneControls.GetSize(); i++ ){
			if( uItemID == m_arrPaneControls[i]->nID ){
				if( m_arrPaneControls[i]->hWnd && ::IsWindow(m_arrPaneControls[i]->hWnd) ) {
					::EnableWindow(m_arrPaneControls[i]->hWnd, bDisable); 
				}
			}
		}
	}

	void SetPaneInfo(int nIndex, UINT nID, UINT nStyle, int cxWidth)
	{
		CStatusBar::SetPaneInfo(nIndex, nID, nStyle, cxWidth);
		BOOL bDisabled = ((nStyle&SBPS_DISABLED) == 0);
		DisableControl(nIndex, bDisabled);
	}

	void SetPaneStyle(int nIndex, UINT nStyle)
	{
		CStatusBar::SetPaneStyle(nIndex, nStyle);
		BOOL bDisabled = ((nStyle&SBPS_DISABLED) == 0);
		DisableControl(nIndex, bDisabled);
	}
	
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CExtStatusControlBar)
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CExtStatusControlBar();

protected:

	struct _STATUSBAR_PANE_
	{
		_STATUSBAR_PANE_(){
			nID = cxText = nStyle = nFlags = 0;
		}
		
		UINT    nID;        // IDC of indicator: 0 => normal text area
		int     cxText;     // width of string area in pixels
		//   on both sides there is a 3 pixel gap and
		//   a one pixel border, making a pane 6 pixels wider
		UINT    nStyle;     // style flags (SBPS_*)
		UINT    nFlags;     // state flags (SBPF_*)
		CString strText;    // text in the pane
	};
	
	struct _STATUSBAR_PANE_CTRL_
	{
		HWND hWnd;
		UINT nID;
		BOOL bAutoDestroy;		
	};
	
	CArray < _STATUSBAR_PANE_CTRL_*, _STATUSBAR_PANE_CTRL_* > m_arrPaneControls; 
	
	_STATUSBAR_PANE_* GetPanePtr(int nIndex) const
	{
		ASSERT((nIndex >= 0 && nIndex < m_nCount) || m_nCount == 0);
		return ((_STATUSBAR_PANE_*)m_pData) + nIndex;
	}
	
	BOOL PaneInfoGet(int nIndex, _STATUSBAR_PANE_* pPane);
	BOOL PaneInfoSet(int nIndex, _STATUSBAR_PANE_* pPane);
	
	void RepositionControls();
	
	// Generated message map functions
protected:
	//{{AFX_MSG(CExtStatusControlBar)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
};

#endif //CONTROLS_H

